"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require("./react-runtime");
var Component = React.Component;
var PropTypes = React.PropTypes;

var invariant = require("invariant");

var _require = require("./data");

var fill = _require.fill;
var resolve = _require.resolve;
var build = _require.build;

var findGLNodeInGLComponentChildren = require("./data/findGLNodeInGLComponentChildren");

function logResult(data, contentsVDOM) {
  if (typeof console !== "undefined" && console.debug // eslint-disable-line
  ) {
      console.debug("GL.Surface rendered with", data, contentsVDOM); // eslint-disable-line no-console
    }
}

module.exports = function (renderVcontainer, renderVcontent, renderVGL) {
  var GLSurface = (function (_Component) {
    _inherits(GLSurface, _Component);

    function GLSurface(props, context) {
      _classCallCheck(this, GLSurface);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(GLSurface).call(this, props, context));

      _this._renderId = 1;
      return _this;
    }

    _createClass(GLSurface, [{
      key: "getGLCanvas",
      value: function getGLCanvas() {
        return this.refs.canvas;
      }
    }, {
      key: "captureFrame",
      value: function captureFrame(callback) {
        var c = this.getGLCanvas();
        invariant(c && c.captureFrame, "captureFrame() should be implemented by GLCanvas");
        invariant(typeof callback === "function", "captureFrame(cb) should have a callback function in first parameter");
        return c.captureFrame.call(c, callback);
      }
    }, {
      key: "render",
      value: function render() {
        var renderId = this._renderId++;
        var props = this.props;
        var style = props.style;
        var width = props.width;
        var height = props.height;
        var children = props.children;
        var debug = props.debug;
        var preload = props.preload;
        var opaque = props.opaque;
        var visibleContent = props.visibleContent;
        var eventsThrough = props.eventsThrough;

        var restProps = _objectWithoutProperties(props, ["style", "width", "height", "children", "debug", "preload", "opaque", "visibleContent", "eventsThrough"]);

        var _findGLNodeInGLCompon = findGLNodeInGLComponentChildren(children);

        var via = _findGLNodeInGLCompon.via;
        var childGLNode = _findGLNodeInGLCompon.childGLNode;

        invariant(childGLNode, "GL.Surface must have in children a GL.Node or a GL Component");

        var _resolve = resolve(fill(build(childGLNode, width, height, preload, via)));

        var data = _resolve.data;
        var contentsVDOM = _resolve.contentsVDOM;
        var imagesToPreload = _resolve.imagesToPreload;

        if (debug) logResult(data, contentsVDOM);

        return renderVcontainer({ width: width, height: height, style: style, visibleContent: visibleContent, eventsThrough: eventsThrough }, contentsVDOM.map(function (vdom, i) {
          return renderVcontent(data.width, data.height, i, vdom, { visibleContent: visibleContent });
        }), renderVGL(_extends({}, restProps, { // eslint-disable-line no-undef
          width: width,
          height: height,
          data: data,
          nbContentTextures: contentsVDOM.length,
          imagesToPreload: imagesToPreload,
          renderId: renderId,
          opaque: opaque,
          visibleContent: visibleContent,
          eventsThrough: eventsThrough
        })));
      }
    }]);

    return GLSurface;
  })(Component);

  GLSurface.displayName = "GL.Surface";

  GLSurface.propTypes = {
    width: PropTypes.number.isRequired,
    height: PropTypes.number.isRequired,
    children: PropTypes.element.isRequired,
    opaque: PropTypes.bool,
    preload: PropTypes.bool,
    autoRedraw: PropTypes.bool,
    eventsThrough: PropTypes.bool,
    visibleContent: PropTypes.bool,
    onLoad: PropTypes.func,
    onProgress: PropTypes.func
  };

  GLSurface.defaultProps = {
    opaque: true,
    preload: false,
    autoRedraw: false,
    eventsThrough: false,
    visibleContent: false
  };

  return GLSurface;
};
//# sourceMappingURL=createSurface.js.map